unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    nmol0: TSpinEdit;
    Label1: TLabel;
    no_adj_mv_in_branch: TSpinEdit;
    Label2: TLabel;
    pbet_inv0: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    StringGrid1: TStringGrid;
    Label5: TLabel;
    interval0: TEdit;
    Calculate: TButton;
    Label6: TLabel;
    Image1: TImage;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    xaxis: TLabel;
    lifetime0: TEdit;
    Label7: TLabel;
    MainMenu1: TMainMenu;
    SaveDialog1: TSaveDialog;
    File1: TMenuItem;
    SaveData1: TMenuItem;
    intrabranch_freq_factor: TSpinEdit;
    no_adjacent_branch: TSpinEdit;
    interbranch_freq_factor: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure CalculateClick(Sender: TObject);
    procedure SaveData1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  life : array of extended;
  gxmin,gxmax,gymin,gymax : extended;
  dxmin,dxmax,dymin,dymax : extended;
  gheight,gwidth : integer;
  txt : TextFile;
  FileDum : string;
  ndata : integer;
  component,intensity : array of extended;
  lifetime : extended;


implementation

{$R *.DFM}

function fx (x: extended): integer;
  begin
   fx := round(gwidth * (x - gxmin) / (gxmax - gxmin));
  end;

function fy (y: extended): integer;
  begin
   fy := gheight - round(gheight * (y - gymin) / (gymax - gymin));
  end;

procedure TForm1.CalculateClick(Sender: TObject);
var
  ii,jj,kk : integer;
  radical : byte;
  nmol, nmv_intra, nmv_inter, intra_ff, inter_ff, bet_ff, sitesel, gosel, pbet_inv,value_temp : integer;
  interval : extended;

  lifemin, lifemax : extended;

  sum : extended;

label 10,20;
begin

  {****Get parameters ******}

  nmol := nmol0.value;                                              
  nmv_intra := no_adj_mv_in_branch.value;
  nmv_inter := no_adjacent_branch.value;
  intra_ff := intrabranch_freq_factor.value;
  inter_ff := interbranch_freq_factor.value;
  pbet_inv := pbet_inv0.value;
  interval := StrToFloat(interval0.text);

  {*************************}



  {****Set Conditions*******}

  setlength(life,nmol+1);
  StringGrid1.RowCount := nmol + 1;
  StringGrid1.Cells[0,0] := 'molecule';
  StringGrid1.Cells[1,0] := 'lifetime';

  {*************************}

  for ii := 1 to nmol do
    begin
      life[ii] := 0;
    end;


  ii := 1;
10:
  radical := 1;
  life[ii] := interval;
20:
  sitesel := random(nmv_intra*intra_ff+nmv_inter*inter_ff+1);
  if sitesel <> 0 then
    begin
      life[ii] := life[ii] + interval;
      goto 20;
    end
  else
    begin
      gosel := random(pbet_inv);
      if gosel <> 0 then
        begin
          life[ii] := life[ii] + interval;
          goto 20;
        end
      else radical := 0;
    end;
  if (radical = 0) then
    begin

      StringGrid1.Cells[0,ii] := IntToStr(ii);
      StringGrid1.Cells[1,ii] := FloatToStr(life[ii]);

      if (ii < nmol) then
        begin
          ii := ii + 1;
          goto 10;
        end;
    end;

 { showmessage('Normal end of calculations! Press OK to continue');  }

  lifemin := 10000000000;
  lifemax := -1000000000;
  for ii := 1 to nmol do
    begin
      if life[ii] > lifemax then lifemax := life[ii];
      if life[ii] < lifemin then lifemin := life[ii];
    end;

  ndata := round(lifemax/interval);

 { showmessage('no. of data = '+IntToStr(ndata)); }

  setlength(intensity,ndata+1);
  setlength(component,ndata+1);

  for ii := 1 to ndata do
    begin
      component[ii] := 0;
    end;

  for ii := 1 to nmol do
    begin
      component[round(life[ii]/interval)] := component[round(life[ii]/interval)] + 1;
    end;

  sum := nmol;
  for ii := 1 to ndata do
    begin
      sum := sum - component[ii];
      intensity[ii] := sum;
    end;

  ii := 0;
  repeat
    ii := ii + 1;
  until intensity[ii] < nmol/2.7182818;
  lifetime := (ii-0.5)*interval;
  lifetime0.text := floattostr(lifetime*1000000000);

     dxmin := 1;
     dxmax := ndata;
     dymin := 0;
     dymax := nmol;
     gxmin := dxmin-(dxmax-dxmin)*0.05;
     gxmax := dxmax+(dxmax-dxmin)*0.05;
     gymin := dymin-(dymax-dymin)*0.05;
     gymax := dymax+(dymax-dymin)*0.05;

     Edit3.Text := FloatToStr(dxmin);
     Edit4.Text := FloatToStr(dxmax);
     Edit1.Text := FloatToStr(dymin);
     Edit2.Text := FloatToStr(dymax);
     xaxis.Caption := 'x '+interval0.text+' [sec]';

      with Image1 do
        begin
          gheight := Image1.Height;
          gwidth := Image1.Width;
          with Canvas do
            begin
              Pen.Color := clWhite;
              Brush.Color := clWhite;
              Rectangle(fx(gxmin),fy(gymin),fx(gxmax),fy(gymax));
              Pen.Color := clGreen;
              Rectangle(fx(dxmin),fy(dymin),fx(dxmax),fy(dymax));
              Pen.Width := 1;
              Pen.Color := clRed;
              MoveTo(fx(1), fy(intensity[1]));
              Ellipse(fx(1)-2,fy(intensity[1])-2,fx(1)+2,fy(intensity[1])+2);
              for ii := 2 to ndata do
                begin
                  LineTo(fx(ii), fy(intensity[ii]));
                  Ellipse(fx(ii)-2,fy(intensity[ii])-2,fx(ii)+2,fy(intensity[ii])+2);
                end;

            end;
        end;
end;

procedure TForm1.SaveData1Click(Sender: TObject);
var
  ii,jj : integer;
begin
  SaveDialog1.FileName := FileDum+'_res.txt';
  with SaveDialog1 do
  if Execute then
    begin
      FileDum := FileName;
      AssignFile(txt,FileDum);
      Rewrite(txt);
      writeln(txt,'no. of molecules for testing Monte Carlo Simulation = ',IntToStr(Form1.nmol0.value));
      writeln(txt,'no. of adjacent MV2+ within each branch to conduct ET = ',IntToStr(Form1.no_adj_mv_in_branch.value));
      writeln(txt,'no. of adjacent branch for conducting ET = ',IntToStr(Form1.no_adjacent_branch.value));
      writeln(txt,'frequency factor for the intrabranch ET = ',IntToStr(Form1.intrabranch_freq_factor.value));
      writeln(txt,'frequency factor for the interbranch ET = ',IntToStr(Form1.interbranch_freq_factor.value));
      writeln(txt,'time spent for each ET event including diffusion = ',Form1.interval0.text,' [sec]');
      writeln(txt,'inverse term of permeation coefficient for BET = ',IntToStr(Form1.pbet_inv0.value));
      writeln(txt,'lifetime estimated [sec] = ',lifetime);
      writeln(txt,'time [sec]	population of CS state');
      for ii := 1 to ndata do
        begin
          writeln(txt,ii*StrToFloat(Form1.interval0.text),'	',intensity[ii]);
        end;
      CloseFile(txt);
    end;
end;

end.
